Attribute VB_Name = "mLVClrHdr"
Option Explicit

'=====================================================================================================================================

'Private Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long

'Purpose     :  Autosizes the specified columns in a listview
'Inputs      :  oLV                 The listview to autosize the columns.
'               [lStartCol]         The first column autosize (defaults to the first column)
'               [lEndCol]           The first last column to autosize (defaults to the last column)
'               [lMaxColWidth]      The max. column width
'               [bIncludeHeading]   If True includes the column heading text when resizing
'Outputs     :  Returns True on success
'Notes       :
'Revisions   :

'=====================================================================================================================================


'Option Explicit
' This is an enhancement of Colored Listview Items example taken from
' Codeguru (VB) site. The Original example is by Chris Eastwood.
' I tried to retain most of the Code, as it is.
'
' By T.Ravi Kiran
' E Mail: t_ravi_kiran@rocketmail.com
' You can also drop me a line at Codeguru site.

'---------------------------------------------------------------------
' Module : mLVDefs : Definitions related to ListView and Header Items.
'---------------------------------------------------------------------

' Code Taken from Code Guru, VB site.
' http://www.codeguru.com/vb
'
'
' Custom Draw Listview Processing
'
' Chris Eastwood May 1998
'
' Feel free to use any of this code as you wish
'

'
' Custom Draw Message to intercept
'
Public Enum WinNotifications
    NM_FIRST = -0& ' (0U- 0U) ' // generic to all controls
    NM_LAST = -99& ' (0U- 99U)
    NM_OUTOFMEMORY = (NM_FIRST - 1)
    NM_CLICK = (NM_FIRST - 2)
    NM_DBLCLK = (NM_FIRST - 3)
    NM_RETURN = (NM_FIRST - 4)
    NM_RCLICK = (NM_FIRST - 5)
    NM_RDBLCLK = (NM_FIRST - 6)
    NM_SETFOCUS = (NM_FIRST - 7)
    NM_KILLFOCUS = (NM_FIRST - 8)
    NM_CUSTOMDRAW = (NM_FIRST - 12)
    NM_HOVER = (NM_FIRST - 13)
End Enum
'
' Win API Rect structure
'
Public Type RECT
    Left As Long
    Top As Long
    Right As Long
    Bottom As Long
End Type


'Note by TRK: These structures get/got modified with every new version
' Common Controls Dll. The newer versons will have new elements added
' at the end, so that this sturcture would still be valid.

'
' Custom Draw Structures
'
' The NMHDR structure contains information about a notification message. The
'pointer
' to this structure is specified as the lParam member of the WM_NOTIFY message.
'
Public Type NMHDR
    hwndFrom As Long       ' Window handle of control sending message
    idFrom As Long         ' Identifier of control sending message
    Code As Long           ' Specifies the notification code
End Type

Public Type NMCUSTOMDRAWINFO
    hdr As NMHDR
    dwDrawStage As Long
    hDC As Long
    rc As RECT
    dwItemSpec As Long
    iItemState As Long
    lItemLParam As Long
End Type

Public Type NMLVCUSTOMDRAW
    nmcmd As NMCUSTOMDRAWINFO
    clrText As Long
    clrTextBk As Long
    'iSubItem As Integer
End Type
'
' Notify Message
'
Public Const WM_NOTIFY& = &H4E
Public Const WM_DRAWITEM = &H2B
'
' Custom Draw Messages
'
Public Const CDDS_PREPAINT& = &H1
Public Const CDDS_POSTPAINT& = &H2
Public Const CDDS_PREERASE& = &H3
Public Const CDDS_POSTERASE& = &H4
Public Const CDDS_ITEM& = &H10000
Public Const CDDS_ITEMPREPAINT& = CDDS_ITEM Or CDDS_PREPAINT
Public Const CDDS_ITEMPOSTPAINT& = CDDS_ITEM Or CDDS_POSTPAINT
Public Const CDDS_ITEMPREERASE& = CDDS_ITEM Or CDDS_PREERASE
Public Const CDDS_ITEMPOSTERASE& = CDDS_ITEM Or CDDS_POSTERASE
Public Const CDDS_SUBITEM& = &H20000

Public Const CDRF_DODEFAULT& = &H0
Public Const CDRF_NEWFONT& = &H2
Public Const CDRF_SKIPDEFAULT& = &H4
Public Const CDRF_NOTIFYPOSTPAINT& = &H10
Public Const CDRF_NOTIFYITEMDRAW& = &H20
Public Const CDRF_NOTIFYSUBITEMDRAW = &H20     ' flags are the same, we candistinguish by context
Public Const CDRF_NOTIFYPOSTERASE& = &H40
Public Const CDRF_NOTIFYITEMERASE& = &H80

' ** List View Messages
Public Const LVM_FIRST = &H1000&               '      // ListView messages
Public Const LVM_SETEXTENDEDLISTVIEWSTYLE = LVM_FIRST + 54 ' << Note the diff
Public Const LVM_GETEXTENDEDLISTVIEWSTYLE = LVM_FIRST + 55 ' << One is Set,Ohter is Get

' For FullRow Selection & Other styles
Public Const SETEXTENDEDSTYLE = &H1000& + 54
Public Const FULLROWSELECT = &H20
Public Const LVS_EX_HEADERDRAGDROP = &H10

'
' Win API Declarations
'
Public Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (pDest As Any, pSource As Any, ByVal dwLength As Long)
Public Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hWnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long

Public Const WM_GETFONT = &H31

Declare Function DrawText Lib "user32" Alias "DrawTextA" (ByVal hDC As Long, ByVal lpStr As String, ByVal nCount As Long, lpRect As RECT, ByVal wFormat As Long) As Long
'Declare Function DrawTextEx Lib "user32" Alias "DrawTextExA" (ByVal hdc As Long, ByVal lpsz As String, ByVal n As Long, lpRect As RECT, ByVal un As Long, lpDrawTextParams As DRAWTEXTPARAMS) As Long
Declare Function SetTextAlign Lib "gdi32" (ByVal hDC As Long, ByVal wFlags As Long) As Long
Declare Function SetTextColor Lib "gdi32" (ByVal hDC As Long, ByVal crColor As Long) As Long
Declare Function SetBkColor Lib "gdi32" (ByVal hDC As Long, ByVal crColor As Long) As Long
Declare Function InvalidateRect Lib "user32" (ByVal hWnd As Long, lpRect As RECT, ByVal bErase As Long) As Long
Declare Function BitBlt Lib "gdi32" (ByVal hDestDC As Long, ByVal X As Long, _
        ByVal Y As Long, ByVal nWidth As Long, ByVal nHeight As Long, _
        ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, _
        ByVal dwRop As Long) As Long

Public Const GW_OWNER = 4
Declare Function GetWindow Lib "user32" (ByVal hWnd As Long, ByVal wCmd As Long) As Long


'Module: LVSubCls01: Subclassing a list view.
Public Const GWL_STYLE = (-16)
Public Const GWL_WNDPROC = (-4)
Private Declare Function GetWindowLong Lib "user32" Alias "GetWindowLongA" (ByVal hWnd As Long, ByVal nIndex As Long) As Long
Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" _
        (ByVal hWnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long
Declare Function CallWindowProc Lib "user32" Alias "CallWindowProcA" _
        (ByVal lpPrevWndFunc As Long, ByVal hWnd As Long, ByVal Msg As Long, _
        ByVal wParam As Long, ByVal lParam As Long) As Long
Const WM_PAINT = &HF
Const WM_ERASEBKGND = &H14



'=====================================================================================================================================


' Listview Colored Headers : Listview control of VB 5.0, doesn't let
' the header control have a colored header buttons. So this code
' lets you have it, by subclasing the listview and intersepting the
' header paiting to achieve the effect.
'
' By T.Ravi Kiran
' E Mail: t_ravi_kiran@rocketmail.com
' You can also drop me a line at Codeguru site.
'
'---------------------------------------------------------------------
' Module : mLVClrHdr : Implementation of Subclassing function and
' CustomDraw notification of Header control to get colored header
' elements.
'
' Main Logic:
' Step 1 : Subclass the ListView and listen for WM_NOTIFY message
'           from its child ( which is the Header Control)
' Step 2 : when you get CustomDraw notification, set the appropriate
'           Colors into the DC, at approp painting stage ITEMPREPAINT
' Step 3 : The actual paiting work is left for the Default procedure.
'
' Future work: For exotic paiting, you can create a OwnerDraw header
' button(s) and handle WM_DRAWITEM. It is possible.
' I am working on this presently (24/7/99), and shall post it on
' Codeguru site, once it is ready.
'---------------------------------------------------------------------
'---------------------------------------------------------------------
' This is an enhancement of Colored Listview Items example taken from
' Codeguru (VB) site. The Original example is by Chris Eastwood.
' I tried to retain most of the Code, as it is. His code uses a
' subclassing control, while this uses none. But you have to follow
' some compulsory steps, so as not to have your VB IDE crashed:-)
'
' ** Important & compulsory steps to use this code:
' Step 1: Setup the subclass :
'            Call HooktoLV(listview1.hwnd,True), where listview1 is the
'       listview control which you want to subclass. Put this line in
'       Form_load procedure of the form that has this listview.
' Step 2 : Set the Foreground and Background colors of the listview
'       header buttons using global variables glHdrTextClr and glHdrBkClr
'       Note that changes take effect only at the next painting cycle.
'       So, for dynamic changing, use listview.refresh to paint immediately.
' Step 3 : Remove the subclass :
'           Call HooktoLV(Byval 0& , False)
'       Preffered point of calling this is in Form_QueryUnload.
'       Form_Unload will also work.
'
'---------------------------------------------------------------------
' BUGS : Only one, as far as i could test:
' 1. This code paints the header buttons *ONLY*. So if you have the
' buttons not covering the entire list view, the portion between the
' last btn and listview right edge, still looks "Grey".
' So, Look for Chris's code elsewhere on Codeguru site to set the
' Last btn to occupy the whole of Client area till right-edge of Lv
'---------------------------------------------------------------------

'------------ Code ------------
'Public members for colors.
Public glHdrTextClr As Long     ' The text color of the Header Btns.
Public glHdrBkClr As Long       ' The background color of Header btns.


Private origLVwinProc As Long
Private m_hooked_Lv As Long

'Alleen gebruiken in Form_Load
Sub HeadersKleuren(Lijst As ListView, Optional Activeren As Boolean = True, Optional Achtergrondkleur As Long = &HE0E0E0, Optional Voorgrondkleur As Long = 0)
'Werkt niet met bijvoorbeeld Achtergrondkleur=vbButtonFace. Het moet een kleur uit het pallet zijn

    HookToLV Lijst.hWnd, Activeren
    If Activeren = True Then
        glHdrBkClr = Achtergrondkleur
        glHdrTextClr = Voorgrondkleur
    End If
End Sub

Public Sub HookToLV(hWnd, b As Boolean)
On Error Resume Next
    If b Then
        origLVwinProc = SetWindowLong(hWnd, GWL_WNDPROC, AddressOf LVSubcls_WProc4Hdr)
        m_hooked_Lv = hWnd
        glHdrBkClr = vbYellow   ' I have set some jarring colors by default
        glHdrTextClr = vbRed    ' so that you will change them to your lining!:-)
        ' change here if you want to use non changing colors!
    Else
        Call SetWindowLong(m_hooked_Lv, GWL_WNDPROC, origLVwinProc)
    End If
End Sub

' This is to subclass the list view and handle the notification
' from its childs, specially the Header Btns.
Public Function LVSubcls_WProc4Hdr(ByVal hWnd As Long, ByVal Msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
    Dim tMessage As NMHDR
    Dim lCode As Long
    Dim tLVRedrawMessage As NMLVCUSTOMDRAW

    Select Case Msg
        Case WM_NOTIFY
            ' The Cs way of Pointer casting has be accomplised by actual
            ' copying of data in VB.
            CopyMemory tMessage, ByVal lParam, Len(tMessage)
            'Debug.Print "WM_Notify to Listview from : 0x"; Hex$(tMessage.hwndFrom); ", "; Hex$(tMessage.idFrom)

            lCode = tMessage.Code
            Select Case lCode
                Case NM_CUSTOMDRAW
                    CopyMemory tLVRedrawMessage, ByVal lParam, Len(tLVRedrawMessage)
                    If tLVRedrawMessage.nmcmd.dwDrawStage = CDDS_PREPAINT Then
                        LVSubcls_WProc4Hdr = CDRF_NOTIFYITEMDRAW
                        Exit Function
                    End If
                    ' If we returned 'NotifyItemDraw' for 'PrePaint'
                    ' we will get more messages.
                    If tLVRedrawMessage.nmcmd.dwDrawStage = CDDS_ITEMPREPAINT Then
                        ' When we get the item-paint message, we will try to
                        ' set the color.
                        '' ** Change here for Color of Your (your User's) Choise
                        SetTextColor tLVRedrawMessage.nmcmd.hDC, glHdrTextClr
                        SetBkColor tLVRedrawMessage.nmcmd.hDC, glHdrBkClr
                        '
                        '' If you want more exotic paiting effects,
                        '' you need to make the Header btns as OwnerDrawn
                        '' Look for my other example.
                        '
                        LVSubcls_WProc4Hdr = CDRF_DODEFAULT
                        Exit Function
                    End If

                    If tLVRedrawMessage.nmcmd.dwDrawStage = CDDS_ITEMPOSTPAINT Then
                        LVSubcls_WProc4Hdr = CDRF_DODEFAULT
                        Exit Function
                    End If
                    'End of Case NM_CUSTOMDRAW
            End Select
            ' for other events, do default proc.
            LVSubcls_WProc4Hdr = CallWindowProc(origLVwinProc, hWnd, Msg, wParam, lParam)
            '        Case WM_DRAWITEM
            '        '    ' It is possible to define the Header Btns as Custom/OwenerDrawn
            '        '   ' in which case you will get a DrawItem Message. and could trycustom
            '        '   ' painting here..
            '            Debug.Print "Wm_DrawItem msg, Custom paiting.....!!"
            '            LVSubcls_WProc4Hdr = CallWindowProc(origLVwinProc, hwnd, Msg, wParam, lParam)
        Case Else
            LVSubcls_WProc4Hdr = CallWindowProc(origLVwinProc, hWnd, Msg, wParam, lParam)
    End Select
End Function

'======================================================================================================

Sub ColorListviewRow(Lv As ListView, RowNbr As Long, RowColor As Double) ' As OLE_COLOR)
     'Waarom MinusAantalKoppen toegevoegd? Gedaan bij toevoegen van extra kolom (in sommige gevallen)
     
'***************************************************************************
'Purpose: Color a ListView Row
'Inputs : Lv - The ListView
'         RowNbr - The index of the row to be colored
'         RowColor - The color to color it
'Outputs: None
'***************************************************************************
    
    Dim itmX As ListItem
    Dim lvSI As ListSubItem
    Dim intIndex As Integer
    
    On Error GoTo ErrorRoutine
    
    Set itmX = Lv.ListItems(RowNbr)
    itmX.ForeColor = RowColor
    For intIndex = 1 To Lv.ColumnHeaders.Count - 1
        Set lvSI = itmX.ListSubItems(intIndex)
        lvSI.ForeColor = RowColor
    Next

    Set itmX = Nothing
    Set lvSI = Nothing
    
    Lv.Refresh
    Exit Sub

ErrorRoutine:

    MsgBox Err.Description

End Sub

Sub BoldListviewRow(Lv As ListView, RowNbr As Long, Vet As Boolean)
'***************************************************************************
'Purpose: Color a ListView Row
'Inputs : Lv - The ListView
'         RowNbr - The index of the row to be colored
'         RowColor - The color to color it
'Outputs: None
'***************************************************************************
    
    Dim itmX As ListItem
    Dim lvSI As ListSubItem
    Dim intIndex As Integer
    
    On Error GoTo ErrorRoutine
    
    Set itmX = Lv.ListItems(RowNbr)
    itmX.Bold = Vet
    For intIndex = 1 To Lv.ColumnHeaders.Count - 1
        Set lvSI = itmX.ListSubItems(intIndex)
        lvSI.Bold = Vet
    Next

    Set itmX = Nothing
    Set lvSI = Nothing
    
    Lv.Refresh
    Exit Sub

ErrorRoutine:

    MsgBox Err.Description

End Sub

'=========================================================================================================================================================================
Function LVAutosizeCols(oLV As ListView, Optional lStartCol As Long = 0, Optional lEndCol As Long = -1, Optional lMaxColWidth As Long = 0, Optional bIncludeHeading As Boolean = True) As Boolean
    Const LVM_FIRST As Long = 4096, LVM_SETCOLUMNWIDTH = (LVM_FIRST + 30)
    Const LVSCW_AUTOSIZE As Long = -1, LVSCW_AUTOSIZE_USEHEADER As Long = -2
    
    Dim lRtn As Long, lParam As Long, lThisCol As Long
    
    On Error GoTo ErrFailed
    'Determine type of autosizing
    If bIncludeHeading Then
        lParam = LVSCW_AUTOSIZE_USEHEADER
    Else
        lParam = LVSCW_AUTOSIZE
    End If
    
    'Determine the last column to resize
    If lEndCol = -1 Then
        lEndCol = oLV.ColumnHeaders.Count - 1
    End If
    
    'Autosize columns
    For lThisCol = lStartCol To lEndCol
        lRtn = SendMessage(oLV.hWnd, LVM_SETCOLUMNWIDTH, lThisCol, ByVal lParam)
        If lMaxColWidth Then
            'Check column doesn't exceed max width
            If oLV.ColumnHeaders(lThisCol + 1).Width > lMaxColWidth Then
                oLV.ColumnHeaders(lThisCol + 1).Width = lMaxColWidth
            End If
        End If
    Next
    
    If lRtn <> 0 Then
        'Return Success
        LVAutosizeCols = True
    End If
    Exit Function

ErrFailed:
    'Debug.Print Err.Description
    'Debug.Assert False
    LVAutosizeCols = False
End Function
