Attribute VB_Name = "ModuleFindFilesApi"
'http://www.vbforums.com/showthread.php?t=244915
Private Declare Function GetAsyncKeyState Lib "user32" (ByVal vKey As Long) As Integer
    '16, 17, 18, 35, &H1, &H2, &H4: Shift, Ctrl, Alt, End, links-, rechts-, middengeklikt

Private Declare Function FindFirstFile Lib "kernel32" Alias "FindFirstFileA" (ByVal lpFileName As String, lpFindFileData As WIN32_FIND_DATA) As Long
Private Declare Function FindNextFile Lib "kernel32" Alias "FindNextFileA" (ByVal hFindFile As Long, lpFindFileData As WIN32_FIND_DATA) As Long
Private Declare Function GetFileAttributes Lib "kernel32" Alias "GetFileAttributesA" (ByVal lpFileName As String) As Long
Private Declare Function FindClose Lib "kernel32" (ByVal hFindFile As Long) As Long

Const MAX_PATH = 260
Const MAXDWORD = &HFFFF
Const INVALID_HANDLE_VALUE = -1
Const FILE_ATTRIBUTE_ARCHIVE = &H20
Const FILE_ATTRIBUTE_DIRECTORY = &H10
Const FILE_ATTRIBUTE_HIDDEN = &H2
Const FILE_ATTRIBUTE_NORMAL = &H80
Const FILE_ATTRIBUTE_READONLY = &H1
Const FILE_ATTRIBUTE_SYSTEM = &H4
Const FILE_ATTRIBUTE_TEMPORARY = &H100

Private Type FILETIME
    dwLowDateTime As Long
    dwHighDateTime As Long
End Type

Private Type WIN32_FIND_DATA
    dwFileAttributes As Long
    ftCreationTime As FILETIME
    ftLastAccessTime As FILETIME
    ftLastWriteTime As FILETIME
    nFileSizeHigh As Long
    nFileSizeLow As Long
    dwReserved0 As Long
    dwReserved1 As Long
    cFileName As String * MAX_PATH
    cAlternate As String * 14
End Type

Private Function StripNulls(OriginalStr As String) As String
    If (InStr(OriginalStr, Chr(0)) > 0) Then
        OriginalStr = Left(OriginalStr, InStr(OriginalStr, Chr(0)) - 1)
    End If
    StripNulls = OriginalStr
End Function

'''Uitzoeken "*.*" of "*"
Function FindFilesAPI(bestandArray() As String, mapArray() As String, ByVal Path As String, Optional SearchStr As String = "*", Optional InclusiefSubDir As Boolean = True, Optional MapOfBestand As Boolean, Optional StopCode As Long = &H1, Optional Grootte) As Boolean
    'KPD-Team 1999
    'E-Mail: [email]KPDTeam@Allapi.net[/email]
    'URL: [url]http://www.allapi.net/[/url]
FindFilesAPI = True

Dim Fso As Object
Set Fso = CreateObject("Scripting.FileSystemObject")

    Dim filename As String ' Walking filename variable...
    Dim DirName As String ' SubDirectory Name
    Dim dirNames() As String ' Buffer for directory name entries
    Dim nDir As Double ' Number of directories in this path
    Dim i As Double ' For-loop counter...
    Dim hSearch As Double ' Search Handle
    Dim WFD As WIN32_FIND_DATA
    Dim Cont As Double
    If Right(Path, 1) <> "\" Then Path = Path & "\"
    ' Search for subdirectories.
    nDir = 0
    ReDim dirNames(nDir)
    Cont = True
    hSearch = FindFirstFile(Path & "*", WFD)
    If hSearch <> INVALID_HANDLE_VALUE Then
        Do While Cont
        If GetAsyncKeyState(StopCode) < 0 Then FindFilesAPI = False: Exit Function
        DirName = StripNulls(WFD.cFileName)
        ' Ignore the current and encompassing directories.
        If (DirName <> ".") And (DirName <> "..") And InclusiefSubDir = True Then
            ' Check for directory with bitwise comparison.
            If GetFileAttributes(Path & DirName) And FILE_ATTRIBUTE_DIRECTORY Then
                dirNames(nDir) = DirName
                nDir = nDir + 1
                ReDim Preserve dirNames(nDir)
            End If
        End If
        Cont = FindNextFile(hSearch, WFD) 'Get next subdirectory.
        Loop
        Cont = FindClose(hSearch)
    End If
    ' Walk through this directory and sum file sizes.
    hSearch = FindFirstFile(Path & SearchStr, WFD)
    Cont = True
    ReDim Preserve mapArray(UBound(mapArray) + 1): mapArray(UBound(mapArray)) = Path
    If hSearch <> INVALID_HANDLE_VALUE And MapOfBestand = False Then
        While Cont
            If GetAsyncKeyState(StopCode) < 0 Then FindFilesAPI = False: Exit Function
            filename = StripNulls(WFD.cFileName)
            If (filename <> ".") And (filename <> "..") Then
                If Fso.FolderExists(Path & filename) = False Then
                    ReDim Preserve bestandArray(UBound(bestandArray) + 1): bestandArray(UBound(bestandArray)) = Path & filename
                    If IsMissing(Grootte) = False Then Grootte = Grootte + Fso.getfile(Path & filename).Size
                End If
            End If
            Cont = FindNextFile(hSearch, WFD) ' Get next file
        Wend
        Cont = FindClose(hSearch)
    End If
    ' If there are sub-directories...
    If InclusiefSubDir = False Then Exit Function
    If nDir > 0 Then
        ' Recursively walk into them...
        For i = 0 To nDir - 1
            FindFilesAPI bestandArray, mapArray, Path & dirNames(i) & "\", SearchStr, InclusiefSubDir, MapOfBestand, StopCode, Grootte
        Next i
    End If
End Function


