Attribute VB_Name = "ModulecToolTip"
'Samen met cTool.cls
'Plaats TipBalloon=True of TipBalloon=False in Form_Load
'Gebruik iha SetTip in Control_MouseMove

'***** This API part only for ListBox and ComboBox controls
'***** to get items rectangle
Private Type RECT
    Left As Long
    Top As Long
    Right As Long
    Bottom As Long
End Type

Private Type COMBOBOXINFO
   cbSize As Long
   rcItem As RECT
   rcButton As RECT
   stateButton  As Long
   hwndCombo  As Long
   hwndEdit  As Long
   hwndList As Long
End Type

Public Declare Function GetComboBoxInfo Lib "user32.dll" (ByVal hwndCombo As Long, CBInfo As COMBOBOXINFO) As Long

Public Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hWnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long
Public Const LB_GETITEMRECT = &H198
Public Const CB_GETDROPPEDCONTROLRECT = &H15F
Public Const CB_GETITEMHEIGHT = &H154
'**************************
'Create new instance of cToolTip class for every control
'we need custom tooltips
Public TTStd As New cToolTip 'This tooltip will be standard
Public TTLbl As New cToolTip ' ToolTip for labels
Public TTCbo As New cToolTip ' ToolTip for ComboBox
Public TTCboItem As New cToolTip ' ToolTip for Combo items


'Geldt voor alle tipteksten
Public TipBalloon As Double

'=========================================================================================================================

'Tips voor alle objecten (speciaal voor labels en images zonder hwnd)
        'Tip: plaats in een frame Labels, Images en ComboBoxen in een PictureBox
Sub SetTip(frm As Form, objLI As Object, Optional Tiptekst As String, Optional Achtergrondkleur, Optional Voorgrondkleur, Optional DuurMs As Double = 3000, Optional Centreren As Boolean)
ObjectInstellen TTLbl, objLI, Tiptekst, Achtergrondkleur, Voorgrondkleur, DuurMs, Centreren
    
Dim rc As RECT
    rc.Left = objLI.Left \ Screen.TwipsPerPixelX
    rc.Top = objLI.Top \ Screen.TwipsPerPixelY
    rc.Bottom = (objLI.Top + objLI.Height) \ Screen.TwipsPerPixelX
    rc.Right = (objLI.Left + objLI.Width) \ Screen.TwipsPerPixelY
    TTLbl.SetToolTipItem frm.hWnd, 0, rc.Left, rc.Top, rc.Right, rc.Bottom, Tiptekst, Centreren
End Sub

'Tips alleen voor objecten met hwnd, muv ComboBox
Sub SetTipStandaard(Obj As Object, Optional Tiptekst As String, Optional Achtergrondkleur, Optional Voorgrondkleur As Double, Optional DuurMs As Double = 3000, Optional Centreren As Boolean)
ObjectInstellen TTStd, Obj, Tiptekst, Achtergrondkleur, Voorgrondkleur, DuurMs, Centreren
End Sub

'Tips alleen voor Comboboxen
Sub SetTipCombo(Obj As Object, Optional Tiptekst As String, Optional Achtergrondkleur, Optional Voorgrondkleur As Double, Optional DuurMs As Double = 3000, Optional Centreren As Boolean)
ObjectInstellen TTCbo, Obj, Tiptekst, Achtergrondkleur, Voorgrondkleur, DuurMs, Centreren
End Sub

Sub ObjectInstellen(cTip As cToolTip, Obj As Object, Optional Tiptekst As String, Optional Achtergrondkleur, Optional Voorgrondkleur, Optional DuurMs As Double = 3000, Optional Centreren As Boolean)
On Error Resume Next

Dim oFont As New StdFont

With cTip
    'oFont.Bold = True
    'oFont.Italic = False
    'oFont.Name = "Tahoma"
    'oFont.Size = 8             'werkt niet
    'Set .Font = oFont
    
    If TipBalloon = True Then .Style = ttStyleBalloon Else .Style = ttStyleStandard
    If IsMissing(Achtergrondkleur) = False Then .BkColor = Achtergrondkleur
    If IsMissing(Voorgrondkleur) = False Then .TxtColor = Voorgrondkleur
    .VisibleTime = DuurMs
    .DelayTime = 100        'tijd voordat tipvenster verschijnt
    On Error Resume Next    'ingeval van Label of Image
    .SetToolTipObj Obj.hWnd, Tiptekst, Centreren
End With
End Sub

Sub WissenTips()
Set TTStd = Nothing
Set TTLbl = Nothing
Set TTCbo = Nothing
Set TTCboItem = Nothing
End Sub

'========================================================================================
'Tips voor ListBox items
Sub TipListBox(Lijst As Control, Tiptekst() As String, Optional Centreren As Boolean)
'Neem Lijst_Scroll op in Lijst_MouseMove
Dim rc As RECT, i As Long

  For i = 0 To Lijst.ListCount - 1
' Get rectangle for item
      SendMessage Lijst.hWnd, LB_GETITEMRECT, i, rc
' Set tooltip exactly for this item
      TTStd.SetToolTipItem Lijst.hWnd, i, rc.Left, rc.Top, rc.Right, rc.Bottom, Tiptekst(i), Centreren
  Next i

End Sub

Sub Lijst_Scroll(Lijst As Control)
  Dim rc As RECT, i As Long
' When scroll ListBox, rectangle changes, so adjust tooltips to new rect
  For i = Lijst.TopIndex To Lijst.ListCount - 1
      SendMessage Lijst.hWnd, LB_GETITEMRECT, i, rc
      TTStd.AjustItemRect Lijst.hWnd, i, rc.Left, rc.Top, rc.Right, rc.Bottom
  Next i
End Sub

'========================================================================================
'Tips voor ComboBox items
Sub TipComboBox(Combo As Control, Tiptekst() As String, Optional Centreren As Boolean)
'Neem Combo_Scroll op in Formulier
  Dim rc As RECT, i As Long, lTemp As Long
  For i = 0 To Combo.ListCount - 1
      rc.Left = 0
      rc.Right = Combo.Width \ Screen.TwipsPerPixelX
      lTemp = SendMessage(Combo.hWnd, CB_GETITEMHEIGHT, i, ByVal 0&)
      rc.Top = (i - Combo.TopIndex) * lTemp
      rc.Bottom = rc.Top + lTemp
' Set tooltip exactly for this item
      TTCboItem.SetToolTipItem GetComboListHandle(Combo), i, rc.Left, rc.Top, rc.Right, rc.Bottom, Tiptekst(i), Centreren
  Next i
End Sub

Sub Combo_Scroll(Combo As ComboBox)
  Dim rc As RECT, i As Long, lTemp As Long
  For i = Combo.TopIndex To Combo.ListCount - 1
      rc.Left = 0
      rc.Right = Combo.Width \ Screen.TwipsPerPixelX
      lTemp = SendMessage(Combo.hWnd, CB_GETITEMHEIGHT, i, ByVal 0&)
      rc.Top = (i - Combo.TopIndex) * lTemp
      rc.Bottom = rc.Top + lTemp
      TTCboItem.AjustItemRect GetComboListHandle(Combo), i, rc.Left, rc.Top, rc.Right, rc.Bottom
  Next i
End Sub

Private Function GetComboListHandle(ctl As ComboBox) As Long
   Dim CBI As COMBOBOXINFO
   CBI.cbSize = Len(CBI)
   Call GetComboBoxInfo(ctl.hWnd, CBI)
   GetComboListHandle = CBI.hwndList
End Function
